;Nigel Goodwin 2004
;SkyDigital 'Backup' IR transmitter
	LIST	p=16F628		;tell assembler what chip we are using
	include "P16F628.inc"		;include the defaults for the chip
	__config 0x3D1C			;sets the configuration settings (oscillator type etc.)

	cblock 	0x20 			;start of general purpose registers
		count1 			;used in delay routine
		counta 			;used in delay routine 
		countb
		count
		Delay_Count
		Bit_Cntr
		Data_Byte
		Dev_Byte
		WDT_Count
		Pulse
		Num_WDT
	endc
	

IR_PORT		Equ	PORTB
IR_TRIS		Equ	TRISB
LED_PORT	Equ	PORTA
LED_TRIS	Equ	TRISA
LED_Pin		Equ	0
IR_Out		Equ	0x00
IR_In		Equ	0x02
Ser_Out		Equ	0x01
Ser_In		Equ	0x02
SW1		Equ	7			;set constants for the switches
SW2		Equ	6
SW3		Equ	5
SW4		Equ	4

TV_ID		Equ	0x01			;TV device ID

But1		Equ	0x00			;numeric button ID's
But2		Equ	0x01
But3		Equ	0x02
But4		Equ	0x03
But5		Equ	0x04
But6		Equ	0x05
But7		Equ	0x06
But8		Equ	0x07
But9		Equ	0x08
ProgUp		Equ	d'16'
ProgDn		Equ	d'17'
VolUp		Equ	d'18'
VolDn		Equ	d'19'



		org	0x0000			;org sets the origin, 0x0000 for the 16F628,
		goto	Start			;this is where the program starts running

		org	0x005	

Start		clrf	WDT_Count
		movlw	0x07
		movwf	CMCON			;turn comparators off (make it like a 16F84)

		clrf	IR_PORT			;make PortB outputs low
 		clrf	TMR0
				
   		bsf 	STATUS,		RP0	;select bank 1
   		movlw 	b'11111110'		;set PortB all inputs, except RB0
   		movwf 	IR_TRIS
		movlw	b'11111111'		;set PortA all inputs
		movwf 	LED_TRIS
		movlw	b'00101111'
		movwf	OPTION_REG
		
		bcf	STATUS,		RP0	;select bank 0
		call	Delay255		;wait for eveything to settle down
		;call	Read_SW			;read setting of switches
		movlw	0x01			;set inital count to one
		movwf	WDT_Count		;set number of timeouts before transmit
		call	Backup			;send first backup
		call	Delay100
		call	Backup			;send second backup
		call	Delay100
		call	BackPlus		;repeat for Sky+
		call	Delay100
		call	BackPlus

Transmit
		sleep				;go to sleep
		decfsz	WDT_Count, f
		goto	Transmit		;check watchdog count, go back and do it again
		call	Backup			;watchdog count expired, send backup copmmand
		call	Delay100
		call	Backup			;send second backup
		call	Delay100
		call	BackPlus		;repeat for Sky+
		call	Delay100
		call	BackPlus
		call	Read_SW			;read switches again		
		movwf	WDT_Count		;set number of timeouts before transmit
		goto	Transmit

Read_SW		movf	PORTB,	w		;read switches
		andlw	b'01110000'		;mask off unused inputs
		movwf	Num_WDT
		rrf	Num_WDT, f
		rrf	Num_WDT, f
		rrf	Num_WDT, f
		rrf	Num_WDT, f
		incf	Num_WDT, f
		movf	Num_WDT, w
		return

Backup		call	Preamble
		MOVLW	0x95			;send backup codes
		call	Xmit_RS232
		MOVLW	0x5A
		call	Xmit_RS232
		retlw	0x00
		
BackPlus	call	PreamPlus
		MOVLW	0x95			;send backup codes
		call	Xmit_RS232
		MOVLW	0x5A
		call	Xmit_RS232
		retlw	0x00		

Skybutton	call	Preamble
		MOVLW	0x95			;send Skybutton codes
		call	Xmit_RS232
		MOVLW	0x55
		call	Xmit_RS232
		retlw	0x00

Power		call	Preamble
		MOVLW	0x55			;send Power codes
		call	Xmit_RS232
		MOVLW	0xA5
		call	Xmit_RS232
		retlw	0x00

Butt0		call	Preamble
		MOVLW	0x55			;send 0 codes
		call	Xmit_RS232
		MOVLW	0x55
		call	Xmit_RS232
		retlw	0x00

Butt1		call	Preamble
		MOVLW	0x55			;send 1 codes
		call	Xmit_RS232
		MOVLW	0x56
		call	Xmit_RS232
		retlw	0x00

Butt2		call	Preamble
		MOVLW	0x55			;send 2 codes
		call	Xmit_RS232
		MOVLW	0x59
		call	Xmit_RS232
		retlw	0x00

Butt3		call	Preamble
		MOVLW	0x55			;send 3 codes
		call	Xmit_RS232
		MOVLW	0x5A
		call	Xmit_RS232
		retlw	0x00

Butt4		call	Preamble
		MOVLW	0x55			;send 4 codes
		call	Xmit_RS232
		MOVLW	0x65
		call	Xmit_RS232
		retlw	0x00

Butt5		call	Preamble
		MOVLW	0x55			;send 5 codes
		call	Xmit_RS232
		MOVLW	0x66
		call	Xmit_RS232
		retlw	0x00

Butt6		call	Preamble
		MOVLW	0x55			;send 6 codes
		call	Xmit_RS232
		MOVLW	0x69
		call	Xmit_RS232
		retlw	0x00

Butt7		call	Preamble
		MOVLW	0x55			;send 7 codes
		call	Xmit_RS232
		MOVLW	0x6A
		call	Xmit_RS232
		retlw	0x00

Butt8		call	Preamble
		MOVLW	0x55			;send 8 codes
		call	Xmit_RS232
		MOVLW	0x95
		call	Xmit_RS232
		retlw	0x00

Butt9		call	Preamble
		MOVLW	0x55			;send 9 codes
		call	Xmit_RS232
		MOVLW	0x96
		call	Xmit_RS232
		retlw	0x00

Preamble	MOVLW	0x0F			;send preamble
		call	Xmit_RS232
		MOVLW	0xCA
		call	Xmit_RS232
		MOVLW	0x93
		call	Xmit_RS232
		MOVLW	0x55
		call	Xmit_RS232
		MOVLW	0x55
		call	Xmit_RS232
		MOVLW	0x55
		call	Xmit_RS232
		retlw	0x00			;end of preamble

PreamPlus	MOVLW	0x0F			;send preamPlus
		call	Xmit_RS232
		MOVLW	0xCA
		call	Xmit_RS232
		MOVLW	0x93
		call	Xmit_RS232
		MOVLW	0x55
		call	Xmit_RS232
		MOVLW	0x55
		call	Xmit_RS232
		MOVLW	0xA5
		call	Xmit_RS232
		retlw	0x00			;end of preamPlus

TX_One		movlw	d'16'
		call	IR_pulse
		retlw	0x00

TX_Zero		movlw	d'16'
		call	NO_pulse
		retlw	0x00

IR_pulse			 	
		MOVWF	count		;  Pulses the IR led at 40KHz
irloop		BSF	IR_PORT,	IR_Out 
		goto	$+1
		goto	$+1 
		goto	$+1
		goto	$+1
		goto	$+1
		goto	$+1
		BCF	IR_PORT,	IR_Out
		goto	$+1
		goto	$+1
		goto	$+1	
		goto	$+1	
		goto	$+1
		NOP			;
		DECFSZ	count,F
		GOTO 	irloop	
		RETLW	0

NO_pulse			 	
		MOVWF	count		;  Doesn't pulse the IR led
irloop2		BCF	IR_PORT,	IR_Out 
		goto	$+1
		goto	$+1
		goto	$+1
		goto	$+1 
		goto	$+1
		goto	$+1
		BCF	IR_PORT,	IR_Out
		goto	$+1	
		goto	$+1	
		goto	$+1
		goto	$+1
		goto	$+1
		NOP			;
		DECFSZ	count,F
		GOTO 	irloop2	
		RETLW	0

Xmit_RS232      MOVWF   Data_Byte            	;move W to Data_Byte
                MOVLW   0x08                 	;set 8 DATA bits out
                MOVWF   Bit_Cntr
Ser_Loop        RLF     Data_Byte , f        	;send one bit
                BTFSC   STATUS    , C
                call	TX_One
                BTFSS   STATUS    , C
                call	TX_Zero
                DECFSZ  Bit_Cntr  , f        	;test if all done
                GOTO    Ser_Loop

                retlw	0x00



;Delay routines

LDelay		MOVWF	count	
ldloop		call	Delay255
		DECFSZ	count,F
		GOTO 	ldloop	
		retlw	0x00

Delay255	movlw	0xff		;delay 255 mS
		goto	d0
Delay100	movlw	d'100'		;delay 100mS
		goto	d0
Delay50		movlw	d'50'		;delay 50mS
		goto	d0
Delay27		movlw	d'27'		;delay 27mS
		goto	d0
Delay20		movlw	d'20'		;delay 20mS
		goto	d0
Delay5		movlw	0x05		;delay 5.000 ms (4 MHz clock)
d0		movwf	count1
d1		movlw	0xC7
		movwf	counta
		movlw	0x01
		movwf	countb
Delay_0		decfsz	counta, f
		goto	$+2
		decfsz	countb, f
		goto	Delay_0

		decfsz	count1	,f
		goto	d1
		retlw	0x00

;end of Delay routines

	end        
        
